<?php 
class ControllerExtensionPaymentSmilePayCredit extends Controller {
	private $error = array(); 

	public function index() {
		$this->load->language('extension/payment/smilepay_credit');   
		 
    	$this->document->setTitle($this->language->get('heading_title')); 
		   
		$this->load->model('setting/setting');
			
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('payment_smilepay_credit', $this->request->post);				
			
			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));
			//$this->load->model('setting/setting');


		}
		//************$this->data 令  $data
		$data['heading_title']    = $this->language->get('heading_title');
		$data['text_enabled']     = $this->language->get('text_enabled');
		$data['text_disabled']    = $this->language->get('text_disabled');
		$data['text_all_zones']   = $this->language->get('text_all_zones');
		
		$data['entry_bank']       = $this->language->get('entry_bank');
		$data['entry_order_status']   = $this->language->get('entry_order_status');
		$data['entry_ordered_status'] = $this->language->get('entry_ordered_status');
		$data['entry_ordered_fail_status'] = $this->language->get('entry_ordered_fail_status');    
    		
		$data['entry_geo_zone']       = $this->language->get('entry_geo_zone');
		$data['entry_status']         = $this->language->get('entry_status');
		$data['entry_sort_order']     = $this->language->get('entry_sort_order');
		
		$data['button_save']          = $this->language->get('button_save');
		$data['button_cancel']        = $this->language->get('button_cancel');

		$data['tab_general']          = $this->language->get('tab_general'); 		
		$data['entry_dcvc']           = $this->language->get('entry_dcvc');		
		$data['entry_total']         = $this->language->get('entry_total');
		$data['entry_mid']            = $this->language->get('entry_mid');
		$data['entry_mid_value']      = $this->language->get('entry_mid_value');
		$data['entry_mid_description']= $this->language->get('entry_mid_description');
 		$data['entry_verifykey'] = $this->language->get('entry_verifykey');
		$data['entry_verifykey_description'] = $this->language->get('entry_verifykey_description');

        $data['entry_bank_note'] =  $this->language->get('entry_bank_note');
        $data['entry_frontend_title'] = $this->language->get('entry_frontend_title');
        $data['entry_rvg2c'] = $this->language->get('entry_rvg2c');
        //eytID
		$data['config_language_id'] = $this->config->get('config_language_id');

 		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}
		
 		if (isset($this->error['warning_dcvc'])) {
			$data['error_warning_dcvc'] = $this->error['warning_dcvc'];
		} else {
			$data['error_warning_dcvc'] = '';
		}
    
		if (isset($this->error['warning_verifykey'])) {
			$data['error_warning_verifykey'] = $this->error['warning_verifykey'];
		} else {
			$data['error_warning_verifykey'] = '';
		}
        if (isset($this->error['warning_rvg2c'])) {
			$data['error_warning_rvg2c'] = $this->error['warning_rvg2c'];
		} else {
			$data['error_warning_rvg2c'] = '';
		}
      $data['breadcrumbs'] = array(); 		
  	  $data['breadcrumbs'][] = array(  	             		
       		'href'      => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true),
       		'text'      => $this->language->get('text_home'),
      		'separator' => FALSE
   		);

   		$data['breadcrumbs'][] = array(
       		'href'      => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true),
       		'text'      => $this->language->get('text_payment'),
      		'separator' => ' :: '
   		);

   		$data['breadcrumbs'][] = array(
       		'href'      => $this->url->link('extension/payment/smilepay_credit', 'user_token=' . $this->session->data['user_token'], true),           
       		'text'      => $this->language->get('heading_title'),
      		'separator' => ' :: '
   		);   		
 
		$data['action'] = $this->url->link('extension/payment/smilepay_credit', 'user_token=' . $this->session->data['user_token'], true);    				
		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true);

		$this->load->model('localisation/language');
		 		
		$languages = $this->model_localisation_language->getLanguages();
		
		/*foreach ($languages as $language) {
			if (isset($this->error['bank_' . $language['language_id']])) {
				$data['error_bank_' . $language['language_id']] = $this->error['bank_' . $language['language_id']];
			} else {
				$data['error_bank_' . $language['language_id']] = '';
			}
		}*/
         
		foreach ($languages as $language) {
			if (isset($this->request->post['payment_smilepay_credit_description_' . $language['language_id']])) {
				$data['smilepay_credit_description_' . $language['language_id']] = $this->request->post['payment_smilepay_credit_description_' . $language['language_id']];
			} else {
                if(!is_null($this->config->get('payment_smilepay_credit_description_' . $language['language_id'])))
				    $data['payment_smilepay_credit_description_' . $language['language_id']] = $this->config->get('payment_smilepay_credit_description_' . $language['language_id']);
                else
                    $data['payment_smilepay_credit_description_' . $language['language_id']] = $this->language->get('text_description');
			}
		}
		
		$data['languages'] = $languages;
		
		if (isset($this->request->post['payment_smilepay_credit_order_status_id'])) {
			$data['payment_smilepay_credit_order_status_id'] = $this->request->post['payment_smilepay_credit_order_status_id'];
		} else {
			$data['payment_smilepay_credit_order_status_id'] = $this->config->get('payment_smilepay_credit_order_status_id'); 
		}
    		
		if (isset($this->request->post['payment_smilepay_credit_ordered_status_id'])) {
			$data['payment_smilepay_credit_ordered_status_id'] = $this->request->post['payment_smilepay_credit_ordered_status_id'];
		} else {
			$data['payment_smilepay_credit_ordered_status_id'] = $this->config->get('payment_smilepay_credit_ordered_status_id'); 
		}  

		if (isset($this->request->post['payment_smilepay_credit_ordered_fail_status_id'])) {
			$data['payment_smilepay_credit_ordered_fail_status_id'] = $this->request->post['payment_smilepay_credit_ordered_fail_status_id'];
		} else {
			$data['payment_smilepay_credit_ordered_fail_status_id'] = $this->config->get('payment_smilepay_credit_ordered_fail_status_id'); 
		}      
		$this->load->model('localisation/order_status');
		
		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
		
		if (isset($this->request->post['payment_smilepay_credit_geo_zone_id'])) {
			$data['payment_smilepay_credit_geo_zone_id'] = $this->request->post['payment_smilepay_credit_geo_zone_id'];
		} else {
			$data['payment_smilepay_credit_geo_zone_id'] = $this->config->get('payment_smilepay_credit_geo_zone_id'); 
		} 
		
		$this->load->model('localisation/geo_zone');										
		$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();
		
		if (isset($this->request->post['payment_smilepay_credit_status'])) {
			$data['payment_smilepay_credit_status'] = $this->request->post['payment_smilepay_credit_status'];
		} else {
			$data['payment_smilepay_credit_status'] = $this->config->get('payment_smilepay_credit_status');
		}
		
		if (isset($this->request->post['payment_smilepay_credit_sort_order'])) {
			$data['payment_smilepay_credit_sort_order'] = $this->request->post['payment_smilepay_credit_sort_order'];
		} else {
			$data['payment_smilepay_credit_sort_order'] = $this->config->get('payment_smilepay_credit_sort_order');
		}
		
		if (isset($this->request->post['payment_smilepay_credit_dcvc'])) {
			$data['payment_smilepay_credit_dcvc'] = $this->request->post['payment_smilepay_credit_dcvc'];
		} else {
			$data['payment_smilepay_credit_dcvc'] = $this->config->get('payment_smilepay_credit_dcvc');
		}
 		if (isset($this->request->post['payment_smilepay_credit_verifykey'])) {
			$data['payment_smilepay_credit_verifykey'] = $this->request->post['payment_smilepay_credit_verifykey'];
		} else {
			$data['payment_smilepay_credit_verifykey'] = $this->config->get('payment_smilepay_credit_verifykey');
		}
 		if (isset($this->request->post['payment_smilepay_credit_total'])) {
			$data['payment_smilepay_credit_total'] = $this->request->post['payment_smilepay_credit_total'];
		} else {
			$data['payment_smilepay_credit_total'] = $this->config->get('payment_smilepay_credit_total');
		}
		
		if (isset($this->request->post['payment_smilepay_credit_mid'])) {
			$data['payment_smilepay_credit_mid'] = $this->request->post['payment_smilepay_credit_mid'];
		} else {
			$data['payment_smilepay_credit_mid'] = $this->config->get('payment_smilepay_credit_mid');
		}
		
		if (isset($this->request->post['payment_smilepay_credit_mid_value'])) {
			$data['payment_smilepay_credit_mid_value'] = $this->request->post['payment_smilepay_credit_mid_value'];
		} else {
			$data['payment_smilepay_credit_mid_value'] = $this->config->get('payment_smilepay_credit_mid_value');
		}
		if (isset($this->request->post['payment_smilepay_credit_frontend_title'])) {
			$data['payment_smilepay_credit_frontend_title'] = $this->request->post['payment_smilepay_credit_frontend_title'];
		} else {
            if(!is_null($this->config->get('payment_smilepay_credit_frontend_title')))
			    $data['payment_smilepay_credit_frontend_title'] = $this->config->get('payment_smilepay_credit_frontend_title');
            else
                $data['payment_smilepay_credit_frontend_title'] = $this->language->get('heading_title');
		}

        if (isset($this->request->post['payment_smilepay_credit_rvg2c'])) {
			$data['payment_smilepay_credit_rvg2c'] = $this->request->post['payment_smilepay_credit_rvg2c'];
		} else {
			$data['payment_smilepay_credit_rvg2c'] = $this->config->get('payment_smilepay_credit_rvg2c');
		}

		//$this->template = 'payment/smilepay_credit.tpl';

		//************令HU
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		
		//$this->response->setOutput($this->render(TRUE), $this->config->get('config_compression'));
		$this->response->setOutput($this->load->view('extension/payment/smilepay_credit', $data));
		//$this->response->setOutput($this->render());
	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'extension/payment/smilepay_credit')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		if (!$this->request->post['payment_smilepay_credit_dcvc']) {
			$this->error['warning_dcvc'] = $this->language->get('error_dcvc');
		}
    
		if (!$this->request->post['payment_smilepay_credit_verifykey']) {
			$this->error['warning_verifykey'] = $this->language->get('error_verifykey');
		}

		if (!$this->request->post['payment_smilepay_credit_rvg2c']) {
			$this->error['warning_rvg2c'] = $this->language->get('error_rvg2c');
		}		    

		if (!$this->error) {
			return TRUE;
		} else {
			return FALSE;
		}	
	}
}
?>