<?php 
error_reporting(0);
//20190129/3.0.3.1
class ControllerCheckoutSmilePayAtmSuccess extends Controller { 
	public function index() {        	  
		$this->load->language('checkout/success');

		if (isset($this->session->data['order_id'])) {
			$this->cart->clear();

			unset($this->session->data['shipping_method']);
			unset($this->session->data['shipping_methods']);
			unset($this->session->data['payment_method']);
			unset($this->session->data['payment_methods']);
			unset($this->session->data['guest']);
			unset($this->session->data['comment']);
			unset($this->session->data['order_id']);
			unset($this->session->data['coupon']);
			unset($this->session->data['reward']);
			unset($this->session->data['voucher']);
			unset($this->session->data['vouchers']);
			unset($this->session->data['totals']);

            unset($this->session->data['doubleclick']);			
		}
     
		 
    
    $this->load->language('checkout/smilepay_atm_success');     
    $this->load->language('common/header');  		
		$this->document->setTitle($this->language->get('heading_title'));  	
        	
	$data['breadcrumbs'] = array();   
  	$data['breadcrumbs'][] = array(
    	'href'      => $this->url->link('common/home'),
    	'text'      => $this->language->get('text_home'),
    	'separator' => false
  	);                                      
  	$data['breadcrumbs'][] = array(
    	'href'      => $this->url->link('checkout/cart','',true),
    	'text'      => $this->language->get('text_basket'),
    	'separator' => $this->language->get('text_separator')
  	);                                      		
		$data['breadcrumbs'][] = array(
			'href'      => $this->url->link('checkout/checkout', '', true),
			'text'      => $this->language->get('text_checkout'),
			'separator' => $this->language->get('text_separator')
		);	                                    					
   	$data['breadcrumbs'][] = array(
      	'href'      => $this->url->link('checkout/smilepay_atm_success','',true),
      	'text'      => $this->language->get('text_success'),
       	'separator' => $this->language->get('text_separator')
   	);

		if ($this->customer->isLogged()) {
    		$data['text_message'] = sprintf($this->language->get('text_customer'), $this->url->link('account/account', '', true), $this->url->link('account/order', '', true), $this->url->link('account/download', '', true), $this->url->link('information/contact'));
		} else {
    		$data['text_message'] = sprintf($this->language->get('text_guest'), $this->url->link('information/contact'));
		} 
                              
  	$data['heading_title'] = $this->language->get('heading_title');
    $data['heading_title_error'] = $this->language->get('heading_title_error');
    
    parse_str(urldecode($this->session->data['smilepay_atm_params']), $notify);
      if ($notify['Status']=="1") {
			$data['error'] =false;
			$notify['Desc']=''; 
			//2.0新增			
			$this->load->model('checkout/order');	
            
            $comment = sprintf($this->language->get('text_success_comment_format'),$notify['SmilePayNO'],$notify['AtmBankNo'],$notify['AtmNo'],$notify['Amount'],iconv("big5","UTF-8",$notify['PayEndDate']));
			//$comment  = "ATM 虛擬帳號，銀行代號：".$notify['AtmBankNo']."，虛擬帳號：".$notify['AtmNo']."，繳費金額：NT$".$notify['Amount']."，繳款截止期限：".iconv("big5","UTF-8",$notify['PayEndDate']);
			$ordered_status = $this->config->get('payment_smilepay_atm_order_status_id');
		//	$this->load->model('payment/smilepay_atm');
		//	$this->model_payment_smilepay_atm->custom_bill($notify['Data_id'],$ordered_status,$comment);    
            if(!isset($this->session->data['smilepay_payment_runonce']) || !$this->session->data['smilepay_payment_runonce'])
            { 
                $this->model_checkout_order->addOrderHistory($notify['Data_id'],$ordered_status,$comment,true);      // success note
            }

            //----711c2cup process start----
            if($this->load->controller('extension/payment/smilepay_711c2cup/is_smilepay_711c2cup',$notify['Data_id']))
            {
                $data['smilepay_711c2c_view']= $this->load->controller('extension/payment/smilepay_711c2cup/runsmseprocess',$notify['Data_id']);
                $this->session->data['smilepay_atm_is711c2cup']=true;
            }  
            //----711c2cup process end----
           

		
      }else{
           $this->document->setTitle($this->language->get('heading_title_error')); // set error title 	
           $this->load->model('checkout/order');		
           //$this->load->model('payment/smilepay_atm');
           $ordered_status = $this->config->get('payment_smilepay_atm_ordered_fail_status_id');
           $comment = sprintf($this->language->get('text_error_message'),$notify['Status'],$notify['Desc']);

           if(!isset($this->session->data['smilepay_payment_runonce']) || !$this->session->data['smilepay_payment_runonce'])
           {
            $this->model_checkout_order->addOrderHistory($notify['Data_id'],$ordered_status, $comment);
            $this->model_checkout_order->addOrderHistory($notify['Data_id'],$ordered_status,$this->language->get('text_error_message_user'),true);//
           }
           //$this->model_payment_smilepay_atm->modify_order_status($notify['Data_id'],$ordered_status, $comment); // add error note
     
           $data['error'] =true;

      }
            $this->session->data['smilepay_payment_runonce'] =true;	
           


			$data['text_custom_bill'] = sprintf($this->language->get('text_custom_bill'),$notify['AtmBankNo'],$notify['AtmNo'],$notify['Amount'],$notify['PayEndDate']);
			$data['text_error_message'] = $this->language->get('text_error_message_user');//sprintf($this->language->get('text_error_message'),$notify['Status'],$notify['Desc']);
			$data['button_continue'] = $this->language->get('text_success');
			$data['continue'] = $this->url->link('common/home');
		
		
			$data['column_left'] = $this->load->controller('common/column_left');
			$data['column_right'] = $this->load->controller('common/column_right');
			$data['content_top'] = $this->load->controller('common/content_top');
			$data['content_bottom'] = $this->load->controller('common/content_bottom');
			$data['footer'] = $this->load->controller('common/footer');
			$data['header'] = $this->load->controller('common/header');
			
			/*if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/common/smilepay_success.tpl')) {
				$this->template = $this->config->get('config_template') . '/template/common/smilepay_success.tpl';
			} else {
				$this->response->setOutput($this->load->view('default/template/common/smilepay_atm_success.tpl', $data));
			}*/
		
            $this->response->setOutput($this->load->view('common/smilepay_atm_success', $data));

 	}
 		public function home() {
		unset($this->session->data['smilepay_atm_params']);

        //---smilepay_711c2cup start---
        if(isset($this->session->data['smilepay_atm_is711c2cup']))
        {
            unset($this->session->data['smilepay_atm_is711c2cup']);
            unset($this->session->data['smilepay_atm_is711c2cup']);
            $this->load->controller('extension/payment/smilepay_711c2cup/clearData');
        }
        //---smilepay_711c2cup end---
	}
	
	public function callback() {
      $this->language->load('checkout/smilepay_atm_success');
      $classif           = $_REQUEST['Classif'];
      $data_id           = $_REQUEST['Data_id'];
      $amount            = $_REQUEST['Amount'];
      $purchamt          = $_REQUEST['Purchamt'];
      $process_date_time = $_REQUEST['Process_date']." ".iconv("big5","UTF-8",$_REQUEST['Process_time']);
      $smseid            = $_REQUEST['Smseid'];
  		$dcvc              = $this->config->get('payment_smilepay_atm_dcvc'); // 您的商店代號
      
      $mid               = $this->config->get('payment_smilepay_atm_mid');
      $mid_value         = trim($this->config->get('payment_smilepay_atm_mid_value'));
      $mid_smilepay      = $_REQUEST['Mid_smilepay'];                   
                                  
       if($mid == true){
         if(!$this->midfun($mid_value,$amount,$smseid,$mid_smilepay)){
            echo  "Possible fraud";
            exit();
         }
       } 
      $this->load->model('checkout/order');	
		  $order_info = $this->model_checkout_order->getOrder($data_id); 
      
      if( $amount == intval(round($order_info['total'])) && $classif == 'B' ){ 
        if (!get_magic_quotes_gpc()) {
           $smseid  = addslashes($smseid);           
           $data_id = addslashes($data_id);
           $process_date_time = addslashes($process_date_time);
        }         
    
        $comment  = sprintf($this->language->get('text_success_payment_comment_format'),$smseid ,$process_date_time);
        $notifycomment = sprintf($this->language->get('text_success_payment_customer_comment_format'),$process_date_time);
        $ordered_status=$this->config->get('payment_smilepay_atm_ordered_status_id');
   //    $this->load->model('payment/smilepay_atm');
     //   $this->model_payment_smilepay_atm->paidorder($data_id,$ordered_status,$comment); 
        $this->model_checkout_order->addOrderHistory($data_id,$ordered_status,$notifycomment,true);      
        $this->model_checkout_order->addOrderHistory($data_id,$ordered_status,$comment,false);     
           
        echo '<Roturlstatus>ocart2.1.1</Roturlstatus>';
      }
      else {        
        echo 'fail2.1.1';     
      }
 	}
    // compute Mid      
    function midfun($Mid_value,$Amount,$Smseid,$Mid_smilepay){   
      $Amount = str_pad($Amount,8,'0',STR_PAD_LEFT);                   
      $Smseid= preg_replace('/[\D]/i','9',substr($Smseid,-4));      
      $dtotal=$Mid_value.$Amount.$Smseid;                              
      
      $i = 1;
      $sum = strlen($dtotal);
      $etemp=0;      
      while ($i <= $sum)
      {
        $ep = substr($dtotal,$i,1);
        $etemp = $etemp + $ep;                
        $i=$i+2;
      }                
      
      $i = 0;  
      $otemp=0;          
      while ($i <= $sum)
      {                                              
        $op = substr($dtotal,$i,1);
        $otemp = $otemp + $op;
        $i=$i+2;
      }
      $mid=($etemp*3)+($otemp*9);    
      
      if($Mid_smilepay == $mid){
        return true;
      }else{
        return false;
      }            
    }   	
  	
}
?>