<?php
//20190129/3.0.3.1
class ControllerExtensionModuleSmilepayExt extends Controller {
	public function index() {
	    
	}
    public function filter_payment_c2cp(&$route, &$data, &$output)
    {
        $this->load->language('checkout/checkout');

        if( isset($data['payment_methods']) && $data['payment_methods'] )
        {
            if(isset( $this->session->data['shipping_method']['code']) && 
                strpos($this->session->data['shipping_method']['code'], 'smilePay_shipping_c2cp.') === 0
                )
            {
                foreach($data['payment_methods'] as $payment)
                {
                    if($payment['code']!= 'smilepay_711c2c')
                    {
                        unset($data['payment_methods'][$payment['code']]);
                    }
                }
            }
            else
            {
                foreach($data['payment_methods'] as $payment)
                {
                    if($payment['code']== 'smilepay_711c2c')
                    {
                        unset($data['payment_methods'][$payment['code']]);
                    }
                }
            }
           
        }
        
        if (empty($data['payment_methods'])) {
			$data['error_warning'] = sprintf($this->language->get('error_no_payment'), $this->url->link('information/contact'));
		}

    }
    public function filter_payment_c2cup(&$route, &$data, &$output)
    {
        $this->load->language('checkout/checkout');
        $supportid = array('smilepay_atm','smilepay_credit','smilepay_csv','smilepay_fami','smilepay_ibon');



        if( isset($data['payment_methods']) && $data['payment_methods'] &&
            isset( $this->session->data['shipping_method']['code']) &&
            strpos($this->session->data['shipping_method']['code'], 'smilePay_shipping_c2cup.') === 0
            )
        {
            foreach($data['payment_methods'] as $payment)
            {
               
                if( !in_array( $payment['code'],$supportid))
                {
                    unset($data['payment_methods'][$payment['code']]);
                }
            }
        }
        
        if (empty($data['payment_methods'])) {
			$data['error_warning'] = sprintf($this->language->get('error_no_payment'), $this->url->link('information/contact'));
		}


    }
    public function filter_payment_ezcatp(&$route, &$data, &$output)
    {
        $this->load->language('checkout/checkout');
        $this->load->model('extension/shipping/smilepay_ezcatp');
        $service_ids = $this->model_extension_shipping_smilepay_ezcatp->getService_code();
        if( isset($data['payment_methods']) && $data['payment_methods'] )
        {
            if(isset( $this->session->data['shipping_method']['code']) &&
                in_array($this->session->data['shipping_method']['code'],$service_ids))
            {
                foreach($data['payment_methods'] as $payment)
                {
                    if($payment['code']!= 'smilepay_ezcat')
                    {
                        unset($data['payment_methods'][$payment['code']]);
                    }
                }
            }
            else
            {
                foreach($data['payment_methods'] as $payment)
                {
                    if($payment['code']== 'smilepay_ezcat')
                    {
                        unset($data['payment_methods'][$payment['code']]);
                    }
                }
            }
           
        }
        
        if (empty($data['payment_methods'])) {
			$data['error_warning'] = sprintf($this->language->get('error_no_payment'), $this->url->link('information/contact'));
		}

    }
    public function filter_payment_ezcatup(&$route, &$data, &$output)
    {
        $this->load->language('checkout/checkout');
        $supportid = array('smilepay_atm','smilepay_credit','smilepay_csv','smilepay_fami','smilepay_ibon');
        $this->load->model('extension/shipping/smilepay_ezcatup');
        $service_ids = $this->model_extension_shipping_smilepay_ezcatup->getService_code();

        if( isset($data['payment_methods']) && $data['payment_methods'] &&
            isset( $this->session->data['shipping_method']['code']) 
        ){
            if( in_array( $this->session->data['shipping_method']['code'], $service_ids) )   
            {
                foreach($data['payment_methods'] as $payment)
                {
               
                    if( !in_array( $payment['code'],$supportid))
                    {
                        unset($data['payment_methods'][$payment['code']]);
                    }
                }
            }
        }
        
        
        if (empty($data['payment_methods'])) {
			$data['error_warning'] = sprintf($this->language->get('error_no_payment'), $this->url->link('information/contact'));
		}


    }

}
?>


