<?php

class ModelExtensionShippingSmilePayShippingC2CP extends Model {

    const SMILEPAY_C2CP_SERVICE_TYPE = 'smilePay_shipping_c2cp';
    const SMILEPAY_C2CP_SERVICE_ID_711 = 'smilePay_shipping_c2cp';
    const SMILEPAY_C2CP_SERVICE_ID_FAMI = 'fami';
    
    
	function getQuote($address) {
        // default  cost 60-19999
        if(! defined("SMILEPAY_SHIPPING_C2CP_MIN_TOTOAL_COST_RANGE"))
            define("SMILEPAY_SHIPPING_C2CP_MIN_TOTOAL_COST_RANGE",60);
        if(! defined("SMILEPAY_SHIPPING_C2CP_MAX_TOTOAL_COST_RANGE"))
            define("SMILEPAY_SHIPPING_C2CP_MAX_TOTOAL_COST_RANGE",19999);
        // set default range
        $smilePay_shipping_c2cp_min_total_cost =SMILEPAY_SHIPPING_C2CP_MIN_TOTOAL_COST_RANGE;
        $smilePay_shipping_c2cp_max_total_cost = SMILEPAY_SHIPPING_C2CP_MAX_TOTOAL_COST_RANGE;
   
        $product_total_cost = $this->cart->getSubTotal();

		$this->load->language('extension/shipping/smilePay_shipping_c2cp');

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int)$this->config->get('shipping_smilePay_shipping_c2cp_geo_zone_id') . "' AND country_id = '" . (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] . "' OR zone_id = '0')");

		if (!$this->config->get('shipping_smilePay_shipping_c2cp_geo_zone_id')) {
			$status = true;
		} elseif ($query->num_rows) {
			$status = true;
		} else {
			$status = false;
		}

        //if(!isset($this->config->get('smilePay_shipping_c2cp_free_cost')))
         //   $status = false;
       //$this->cart->getTotal();  //include tax
       //$this->cart->getSubTotal()  //  product cost
 
        $total = 0;
        $totals = array();
		$taxes = $this->cart->getTaxes();
		$total_data = array(
						'totals' => &$totals,
						'taxes'  => &$taxes,
						'total'  => &$total
					);

		//get total	
		if (($this->config->get('config_customer_price') && $this->customer->isLogged()) || !$this->config->get('config_customer_price')) {
		    $sort_order = array();

		    $results = $this->model_setting_extension->getExtensions('total');

		    foreach ($results as $key => $value) {
			    $sort_order[$key] = $this->config->get('total_'.$value['code'] . '_sort_order');
		    }

		    array_multisort($sort_order, SORT_ASC, $results);

		    foreach ($results as $result) {
			    if ($this->config->get('total_'.$result['code'] . '_status')) {
				    $this->load->model('extension/total/' . $result['code']);
                    $this->{'model_extension_total_' . $result['code']}->getTotal($total_data);   
            
			    }
		    }
					
		}

         
        // $product_total_cost = $total_data['total'];
        
         
        //set free or cost
        /*if(  $this->config->get('shipping_smilePay_shipping_c2cp_free_cost'))
            $product_total_cost > $this->config->get('shipping_smilePay_shipping_c2cp_free_cost') ? $ship_cost =0.00 :$ship_cost = $this->config->get('shipping_smilePay_shipping_c2cp_cost'); 
        else
            $ship_cost = $this->config->get('shipping_smilePay_shipping_c2cp_cost'); */
            
        $free = false;
        //set free or cost
        if(  $this->config->get('shipping_smilePay_shipping_c2cp_free_cost'))
            $product_total_cost > $this->config->get('shipping_smilePay_shipping_c2cp_free_cost') ? $free =true :$free =false; 
        //filter total cost between max total cost and min total cost->
        if(!is_null($this->config->get('shipping_smilePay_shipping_c2cp_min_total_cost')) && $this->config->get('shipping_smilePay_shipping_c2cp_min_total_cost')!="")
            $smilePay_shipping_c2cp_min_total_cost = $this->config->get('shipping_smilePay_shipping_c2cp_min_total_cost');
        if(!is_null( $this->config->get('shipping_smilePay_shipping_c2cp_max_total_cost')) && $this->config->get('shipping_smilePay_shipping_c2cp_max_total_cost')!="")
            $smilePay_shipping_c2cp_max_total_cost = $this->config->get('shipping_smilePay_shipping_c2cp_max_total_cost');

         
        if( $product_total_cost <   $smilePay_shipping_c2cp_min_total_cost || $product_total_cost > $smilePay_shipping_c2cp_max_total_cost)
        {
          
            $status = false;
        }
        //<-----------------------------

		$method_data = array();

       
        if(!is_null($this->config->get('shipping_smilePay_shipping_c2cp_frontend_title')))
        {
          if(trim($this->config->get('shipping_smilePay_shipping_c2cp_frontend_title')) != "" )
             $quote_data_title = $this->config->get('shipping_smilePay_shipping_c2cp_frontend_title');
          else
             $this->language->get('text_description');
        } 
        else
          $quote_data_title = $this->language->get('text_description');
         
		if ($status) {
			$quote_data = array();

			/*$quote_data['smilePay_shipping_c2cp'] = array(
				'code'         => 'smilePay_shipping_c2cp.smilePay_shipping_c2cp',
				'title'        => $this->language->get('text_711_title'),
                'tax_class_id' => 0,
				'cost'         => $ship_cost ,
				'text'         =>$this->currency->format($ship_cost, $this->config->get('config_currency'))// $this->currency->format($this->config->get('smilePay_shipping_c2cp_cost'))
			);*/
            $service_ids = $this->get_shipping_setting_table();

            foreach($service_ids as $key =>$val)
            {
                if(!$this->config->get('shipping_smilePay_shipping_c2cp_'  .  $val['enabled']))
                {
                    continue;
                }
                if(!$free)
                {
                    $ship_cost = $this->config->get('shipping_smilePay_shipping_c2cp_'.  $val['cost']);
                }
                else
                    $ship_cost = 0;
                
                $title= $this->config->get('shipping_smilePay_shipping_c2cp_'.  $val['title']);

                $quote_data[$val['id']] = array(
				    'code'         =>  self::SMILEPAY_C2CP_SERVICE_TYPE . "." .$val['id'],
				    'title'        => $title,
                    'tax_class_id' => 0,
				    'cost'         => $ship_cost ,
				    'text'         =>$this->currency->format($ship_cost, $this->config->get('config_currency'))// $this->currency->format($this->config->get('smilePay_shipping_ezcatp_cost'))
			    );
            }
			$method_data = array(
				'code'       => 'smilePay_shipping_c2cp',
				'title'      => $quote_data_title,
				'quote'      => $quote_data,
				'sort_order' => $this->config->get('shipping_smilePay_shipping_c2cp_sort_order'),
				'error'      => false
			);
		}

		return $method_data;
	}

    
    protected function get_shipping_setting_table()
    {
         $shipping_setting_table = array(
                                            '711'=>array(
                                                        'id' =>  self::SMILEPAY_C2CP_SERVICE_ID_711,
                                                        'enabled'=>'711_enabled',
                                                        'cost' => 'cost',
                                                        'title' => '711_frontend_title' 
                                                    ),
                                            'fami'=>array(
                                                        'id' => self::SMILEPAY_C2CP_SERVICE_ID_FAMI,
                                                        'enabled'=>'fami_enabled',
                                                        'cost' => 'fami_cost',
                                                        'title' => 'fami_frontend_title' 
                                                    )
                                        );
        return $shipping_setting_table;
    }

     public function get_smilepay_c2cp_type()
     {
        return array(
                    self::SMILEPAY_C2CP_SERVICE_TYPE . "." . self::SMILEPAY_C2CP_SERVICE_ID_711 => '7NET',
                    self::SMILEPAY_C2CP_SERVICE_TYPE . "." . self::SMILEPAY_C2CP_SERVICE_ID_FAMI => 'FAMI'
                );
     }

}